# Parallelized N-Gram Language Modeling with Stupid Backoff for Text Generation

## Project Report - COMS 4995 Parallel Functional Programming

### Dave Epstein (UNI: ne2260)

#### Compilation and execution

To compile, simply run `stack build` in the program directory.

To run, run `stack exec -- stupidlm-exe`. This (or adding the `-h`/`--help` flag) will provide a full listing of command line options, but I include some common usages here. The program is compiled with RTS support, so `+RTS -N8` will run with 8 HECs, for example.

I tested my program on a large text file. Please download this file from:
https://cv.cs.columbia.edu/dave/big_PFP_corpus.txt

To just build an n-gram model (with n=5) from the downloaded corpus, run:

`stack exec -- stupidlm-exe -m buildOnly -f PATH_TO_CORPUS -n 5 +RTS -N8`

To run only on the first 10,000 documents in that corpus, add `--ndocs 10000` before `+RTS`.

To test the sentence probability feature, use `-m score`. To test beam search, use `-m complete --complete-mode beamSearch`. Both modes will eagerly prompt for some input text, and lazily run necessary computations to compute a result. This may take some time (especially at first) since the prompt is displayed immediately and not after the language model is fully built.